// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!


#include <glibmm.h>

#include <goocanvasmm/polyline.h>
#include <goocanvasmm/private/polyline_p.h>


/* Copyright (C) 1998-2006 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <goocanvaspolyline.h>


namespace Goocanvas
{

Polyline::Polyline(bool close_path, const Points& points )
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Goocanvas::ItemSimple(Glib::ConstructParams(polyline_class_.init(), "close_path",close_path ? TRUE : FALSE, static_cast<char*>(0)))
{
#ifdef GLIBMM_PROPERTIES_ENABLED
  property_points() = points ;
#else
  set_property("points", points);
#endif
}

Polyline::Polyline(double x1, double y1, double x2, double y2)
:
   // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Goocanvas::ItemSimple(Glib::ConstructParams(polyline_class_.init(), "close_path",FALSE , static_cast<char*>(0)))
{
  double data[4] = {x1, y1, x2, y2};
  Goocanvas::Points points(2, data);

#ifdef GLIBMM_PROPERTIES_ENABLED
  property_points() = points ;
#else
  set_property("points", points);
#endif
}

} //namespace Goocanvas


namespace
{
} // anonymous namespace


namespace Glib
{

Glib::RefPtr<Goocanvas::Polyline> wrap(GooCanvasPolyline* object, bool take_copy)
{
  return Glib::RefPtr<Goocanvas::Polyline>( dynamic_cast<Goocanvas::Polyline*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Goocanvas
{


/* The *_Class implementation: */

const Glib::Class& Polyline_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &Polyline_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(goo_canvas_polyline_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:

  }

  return *this;
}


void Polyline_Class::class_init_function(void* g_class, void* class_data)
{
  const auto klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);


}


Glib::ObjectBase* Polyline_Class::wrap_new(GObject* object)
{
  return new Polyline((GooCanvasPolyline*)object);
}


/* The implementation: */

GooCanvasPolyline* Polyline::gobj_copy()
{
  reference();
  return gobj();
}

Polyline::Polyline(const Glib::ConstructParams& construct_params)
:
  Goocanvas::ItemSimple(construct_params)
{

}

Polyline::Polyline(GooCanvasPolyline* castitem)
:
  Goocanvas::ItemSimple((GooCanvasItemSimple*)(castitem))
{}


Polyline::Polyline(Polyline&& src) noexcept
: Goocanvas::ItemSimple(std::move(src))
{}

Polyline& Polyline::operator=(Polyline&& src) noexcept
{
  Goocanvas::ItemSimple::operator=(std::move(src));
  return *this;
}

Polyline::~Polyline() noexcept
{}


Polyline::CppClassType Polyline::polyline_class_; // initialize static member

GType Polyline::get_type()
{
  return polyline_class_.init().get_type();
}


GType Polyline::get_base_type()
{
  return goo_canvas_polyline_get_type();
}


Glib::RefPtr<Polyline> Polyline::create(bool close_path, const Points& coords)
{
  return Glib::RefPtr<Polyline>( new Polyline(close_path, coords) );
}

Glib::RefPtr<Polyline> Polyline::create(double x1, double y1, double x2, double y2)
{
  return Glib::RefPtr<Polyline>( new Polyline(x1, y1, x2, y2) );
}


Glib::PropertyProxy< double > Polyline::property_arrow_length() 
{
  return Glib::PropertyProxy< double >(this, "arrow-length");
}

Glib::PropertyProxy_ReadOnly< double > Polyline::property_arrow_length() const
{
  return Glib::PropertyProxy_ReadOnly< double >(this, "arrow-length");
}

Glib::PropertyProxy< double > Polyline::property_arrow_tip_length() 
{
  return Glib::PropertyProxy< double >(this, "arrow-tip-length");
}

Glib::PropertyProxy_ReadOnly< double > Polyline::property_arrow_tip_length() const
{
  return Glib::PropertyProxy_ReadOnly< double >(this, "arrow-tip-length");
}

Glib::PropertyProxy< double > Polyline::property_arrow_width() 
{
  return Glib::PropertyProxy< double >(this, "arrow-width");
}

Glib::PropertyProxy_ReadOnly< double > Polyline::property_arrow_width() const
{
  return Glib::PropertyProxy_ReadOnly< double >(this, "arrow-width");
}

Glib::PropertyProxy< bool > Polyline::property_close_path() 
{
  return Glib::PropertyProxy< bool >(this, "close-path");
}

Glib::PropertyProxy_ReadOnly< bool > Polyline::property_close_path() const
{
  return Glib::PropertyProxy_ReadOnly< bool >(this, "close-path");
}

Glib::PropertyProxy< bool > Polyline::property_end_arrow() 
{
  return Glib::PropertyProxy< bool >(this, "end-arrow");
}

Glib::PropertyProxy_ReadOnly< bool > Polyline::property_end_arrow() const
{
  return Glib::PropertyProxy_ReadOnly< bool >(this, "end-arrow");
}

Glib::PropertyProxy< Points > Polyline::property_points() 
{
  return Glib::PropertyProxy< Points >(this, "points");
}

Glib::PropertyProxy_ReadOnly< Points > Polyline::property_points() const
{
  return Glib::PropertyProxy_ReadOnly< Points >(this, "points");
}

Glib::PropertyProxy< bool > Polyline::property_start_arrow() 
{
  return Glib::PropertyProxy< bool >(this, "start-arrow");
}

Glib::PropertyProxy_ReadOnly< bool > Polyline::property_start_arrow() const
{
  return Glib::PropertyProxy_ReadOnly< bool >(this, "start-arrow");
}


} // namespace Goocanvas


